CXX=g++
CXXFLAGS=-std=gnu++0x -D_GLIBCXX_USE_NANOSLEEP -g
LDFLAGS=-pthread -g
OUTDIR=bin/

SOCKSSERVER=$(OUTDIR)SOCKSServer
SOCKSSERVERSOURCES=$(wildcard Server/*.cpp)
SOCKSSERVEROBJECTS=$(SOCKSSERVERSOURCES:.cpp=.o)

SOCKSCLIENT=$(OUTDIR)SOCKSClient
SOCKSCLIENTSOURCES=$(wildcard Client/*.cpp)
SOCKSCLIENTOBJECTS=$(SOCKSCLIENTSOURCES:.cpp=.o)


PPTPSERVER=$(OUTDIR)PPTPServer
PPTPSERVERSOURCES=$(wildcard PPTP_Server/*.cpp)
PPTPSERVEROBJECTS=$(PPTPSERVERSOURCES:.cpp=.o)

PPTPCLIENT=$(OUTDIR)PPTPClient
PPTPCLIENTSOURCES=$(wildcard PPTP_Client/*.cpp)
PPTPCLIENTOBJECTS=$(PPTPCLIENTSOURCES:.cpp=.o)


SHAREDSOURCES=$(wildcard SharedLibraries/*.cpp)
SHAREDOBJECTS=$(SHAREDSOURCES:.cpp=.o)
SHARED=$(OUTDIR)sharedLibraries.a

TESTSOURCES=$(wildcard Tests/*.cpp)
TESTSOBJECTS=$(TESTSOURCES:.cpp=.o)
TESTS= $(patsubst Tests/%.o,bin/%, $(TESTSOBJECTS))

all: socks 

socks: $(SOCKSSERVER) $(SOCKSCLIENT)

pptp: $(PPTPSERVER) $(PPTPCLIENT)

run: all
	(cd bin; ulimit -s 256; ./$(SOCKSServer)>../serverlog&)
	(cd bin; ulimit -s 256; ./$(SOCKSCLIENT)>../clientlog&)
	(cd bin; ulimit -s 512; ./Test1)
tests: $(TESTS)

stop:
	killall SOCKSServer -9

clean: 
	rm -f $(SOCKSSERVEROBJECTS)
	rm -f $(SOCKSCLIENTOBJECTS)
	rm -f $(SHAREDOBJECTS)

$(SOCKSSERVER): $(SHAREDOBJECTS) $(SOCKSSERVEROBJECTS) 
	$(CXX) $(LDFLAGS) $(SHAREDOBJECTS) $(SOCKSSERVEROBJECTS) -o $@

$(SOCKSCLIENT): $(SHAREDOBJECTS) $(SOCKSCLIENTOBJECTS)
	$(CXX) $(LDFLAGS) $(SHAREDOBJECTS) $(SOCKSCLIENTOBJECTS) -o $@

$(PPTPSERVER): $(SHAREDOBJECTS) $(PPTPSERVEROBJECTS) 
	$(CXX) $(LDFLAGS) $(SHAREDOBJECTS) $(PPTPSERVEROBJECTS) -o $@

$(PPTPCLIENT): $(SHAREDOBJECTS) $(PPTPCLIENTOBJECTS)
	$(CXX) $(LDFLAGS) $(SHAREDOBJECTS) $(PPTPCLIENTOBJECTS) -o $@

$(SHARED): $(SHAREDOBJECTS)	

$(TESTS): $(TESTSOBJECTS) $(SHAREDOBJECTS)
	$(CXX) $(LDFLAGS) $(SHAREDOBJECTS) $< -o $@

.cpp.o: %.cpp
	$(CXX) -ISharedLibraries $(CXXFLAGS) -c $< -o $@
